#!/usr/bin/perl

#    ADC2000NG - banner exchange perl software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<adc.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}

($user,$username,$credits,$rrandcheck,$method)=split("&",$ENV{QUERY_STRING});
if ($method eq "final")
{
open (F,"<$basepath/$user/session.spx");
$rrandchecks=<F>;
close (F);
unlink ("$basepath/$user/session.spx");
$rrandcheck=time unless ($rrandcheck);
if (-e "$basepath/$user/spx.last")
{
	$sincelast=-M "$basepath/$user/spx.last";
	if ($sincelast>$guarddelay/86400)
	{
		open (F,">$basepath/$user/spx.last");
		close (F);
	}
}
else
{
	$sincelast=99999999;
	open (F,">$basepath/$user/spx.last");
	close (F);
}
open (F, "<$basepath/adcenter.db");
flock(F,$LOCK_EX);
while($line=<F>)
{
	chop($line);
	($usernm,$urlz,$usrgroup,$country,$ratio,$referuser,$weight)=split("\t",$line);
	if ($usernm eq $user)
	{
		$userratio=$ratio;
		$refus=$referuser;
	}
	if ($usernm eq $username)
	{
		$url=$urlz;
		$found=1;
	}
}
flock(F,$LOCK_UN);
close (F);
($rat1,$rat2)=split(":",$defaultratiospx);
if ($rat2){$defaultratiospx=$rat1/$rat2;}else{$defaultratiospx=0;}
if ($defaultratiospx=~/\./){$defaultratiospx=substr($defaultratiospx,0,5);}
open (FICR,"+<$basepath/credits.spx");
flock(FICR,$LOCK_EX);
@credits=<FICR>;
foreach(@credits)
{
	chop;
	($tusr,$tval)=split("\t",$_);
	$credit{$tusr}=$tval;
}
if ($sincelast>$guarddelay/86400 && $rrandcheck==$rrandchecks)
{
	$credit{$user}+=$defaultratiospx;
	if ($refus)
	{
		($rat1,$rat2)=split(":",$refratio);
		if ($rat2){$refratio=$rat1/$rat2;}else{$refratio=0;}
		if ($refratio=~/\./){$refratio=substr($refratio,0,5);}
		$credit{$refus}+=$refratio;
	}
}
truncate(FICR,0);
seek(FICR,0,0);
foreach $key (keys %credit){print FICR "$key\t$credit{$key}\n";}
flock(FICR,$LOCK_UN);
close (FICR);
if ($sincelast>$guarddelay/86400 && $rrandcheck==$rrandchecks)
{
	if ($refus)
	{
		unless (-e "$basepath/$refus/referal.spx")
		{
			open (F,">$basepath/$refus/referal.spx");
			flock(F,$LOCK_EX);
			print F "0";
			flock(F,$LOCK_UN);
			close (F);
		}
		open (F,"+<$basepath/$refus/referal.spx");
		flock(F,$LOCK_EX);
		$credit=<F>;
		$credit=$credit+$refratio;
		truncate (F,0);
		seek (F,0,0);
		print F $credit;
		flock(F,$LOCK_UN);
		close(F);
	}
}
$credits=$credit{$user};
if ($sincelast>$guarddelay/86400 && $rrandcheck==$rrandchecks)
{
	$status="Account credited";
}
elsif ($sincelast<=$guarddelay/86400)
{
	$status="Account wasnt credited. Page changed too fast.";
}
else
{
	$status="Account wasnt credited. Invalid session.";
}
$url=$furl unless ($found);
$closeframe="<a href=\"$url\" target=\"_top\">Close frame</a>";
}
else
{
open (F,">$basepath/$user/session.spx");
print F $rrandcheck;
close (F);
$status="Please wait for credit";
}
srand;
$rranddig=rand(1);
open (F,"<$adcpath/template/spxframe.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
if ($method ne "final")
{
	print "Refresh: $guarddelay2;url=$cgi/adcnav.pl?$user&$username&$credits&$rrandcheck&final\n";
}
print "content-type: text/html\n\n";
eval $htmlpage;
