#!/usr/bin/perl

#    ADC2000NG - banner exchange perl software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<adc.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}

($ldate=scalar gmtime(time+$gmtzone*3600))=~s/ \d+:\d+:\d+//;
($day,$month,$date,$time,$year)=split(" ",scalar gmtime(time+$gmtzone*3600));
($hours)=split(":",$time);
if ($hours==0){$hourr=23;}
else {$hourr=$hours-1;}
$lmon=$cal{$month};
$ldte=$date;
$lmon="0".$lmon if (length($lmon)==1);
$ldte="0".$date if (length($date)==1);
$lastact="$year$lmon$ldte";
$time=~s/://g;
@data=split("; ",$ENV{HTTP_COOKIE});
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex ($1))/eg;
		$cook{$field}=$value;
	}
}
@data=();
($username,$user)=split("&",$ENV{QUERY_STRING});
if (!$user || !$username || !(-d "$basepath/$user") || !(-d "$basepath/$username"))
{
	print "content-type: text/html\n\n";
	print qq~Wrong parameters~;
	exit;
}
unless (-e "$basepath/$user/affilc.spx")
{
	open (F,">$basepath/$user/affilc.spx");
	flock(F,$LOCK_EX);
	print F "0";
	flock(F,$LOCK_UN);
	close (F);
}
open (F,"+<$basepath/$user/affilc.spx");
flock(F,$LOCK_EX);
$affilx_data=<F>;
$affilx_data+=1;
truncate(F,0);
seek(F,0,0);
print F $affilx_data;
flock(F,$LOCK_UN);
close (F);
open (FICR,"+<$basepath/credits.spx");
flock(FICR,$LOCK_EX);
@credits=<FICR>;
foreach(@credits)
{
	chop;
	($tusr,$tval)=split("\t",$_);
	$credit{$tusr}=$tval;
}
open (F, "<$basepath/adcenter.db");
flock(F,$LOCK_EX);
while($line=<F>)
{
	chop($line);
	($usernm,$urlz,$usrgroup,$country,$ratio,$referuser,$weight)=split("\t",$line);
	if ($usernm eq $user)
	{
		$userratio=$ratio;
		$refus=$referuser;
	}
	if ($usernm eq $username)
	{
		$url=$urlz;
		$found=1;
	}
}
flock(F,$LOCK_UN);
close (F);
$credit{$username}-=1 if ($credit{$username}>1);
truncate(FICR,0);
seek(FICR,0,0);
foreach $key (keys %credit){print FICR "$key\t$credit{$key}\n";}
flock(FICR,$LOCK_UN);
close (FICR);

unless (-e "$basepath/$username/impressions.spx")
{
	open (F,">$basepath/$username/impressions.spx");
	flock(F,$LOCK_EX);
	flock(F,$LOCK_UN);
	close (F);
}
open (STAT,"+<$basepath/$username/impressions.spx");
flock(STAT,$LOCK_EX);
while($line=<STAT>)
{
	chop($line);
	($tkey,$tval)=split("\t",$line);
	$stats{$tkey}=$tval;
}
@stats=split ("#",$stats{$ldate});
$stats[$hours]=$stats[$hours]+1;
$stats{$ldate}=join("#",@stats[0..23]);
truncate(STAT,0);
seek(STAT,0,0);
foreach $key (keys %stats){print STAT "$key\t$stats{$key}\n";}
flock(STAT,$LOCK_UN);
close (STAT);
open (F,"+<$basepath/$username/affiliate.spx");
flock(F,$LOCK_EX);
@lines=<F>;
foreach (@lines)
{
	($arg1,$arg2,$arg3,$arg4)=split("\t",$_);
	if ($arg1 eq $user)
	{
		chop($arg4);
		$arg4++;
		$_="$arg1\t$arg2\t$arg3\t$arg4\n";
		$foundflag=1;
		last;
	}
}
truncate(F,0);
seek(F,0,0);
print F @lines;
flock(F,$LOCK_UN);
close (F);
if ($username eq $yourname)
{
	$cook{smartshow_spx}="";
}
else
{
	chop($cook{smartshow_spx});
	$cook{smartshow_spx}.=",$username";
	$cook{smartshow_spx}.=",";
}
($day,$date,$month,$time,$year)=split(" ",scalar gmtime(time+$smartshowdelay*60*60*24));
$month="0$month" if (length($month)==1);
($days,$dates,$months,$times,$years)=split(" ",scalar gmtime(time+$keepcookie*60+$diftime));
$months="0$months" if (length($months)==1);
$url=$furl unless ($found);
srand;
$rranddig=rand(1);
open (F,"<$adcpath/template/spxidx.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "P3P: CP=\"UNI\"\n";
print "set-cookie: smartshow_spx=$cook{smartshow_spx}; \n";
print "content-type: text/html\n\n";
eval $htmlpage;
