#!/usr/bin/perl

#    ADC2000NG - banner exchange perl software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<adc.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}

@data=split("; ",$ENV{HTTP_COOKIE});
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex ($1))/eg;
		$cook{$field}=$value;
	}
}
@data=();
($ldate=scalar gmtime(time+$gmtzone*3600))=~s/ \d+:\d+:\d+//;
($day,$month,$date,$time,$year)=split(" ",scalar gmtime(time+$gmtzone*3600));
($hours)=split(":",$time);
if ($hours==0){$hourr=23;}
else {$hourr=$hours-1;}
$lmon=$cal{$month};
$ldte=$date;
$lmon="0".$lmon if (length($lmon)==1);
$ldte="0".$date if (length($date)==1);
$lastact="$year$lmon$ldte";
$time=~s/://g;

($user)=split("&",$ENV{QUERY_STRING});
if (!$user || !(-d "$basepath/$user"))
{
	print "HTTP/1.0 200 OK\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	print qq~<table border=0 cellpadding=0 cellspacing=0><tr><td><font size=2><b>You are not registered user. Please, register first with <a href="$adcenter">us</a></b></font></td></tr></table>~;
	exit;
}
open (F,"$basepath/proxy.db");
flock(F,$LOCK_EX);
@proxy=<F>;
flock(F,$LOCK_UN);
close (F);
if (@proxy)
{
$proxy=join("",@proxy);
$proxy=~s/\n/#/g;
$proxy="#$proxy";
$rem_adr=$ENV{REMOTE_ADDR};
$rem_host=$ENV{REMOTE_HOST};
if ($proxy=~/\#$rem_adr\#/ || $proxy=~/\#$rem_host\#/)
{
	print "HTTP/1.0 200 OK\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	print qq~<table border=0 cellpadding=0 cellspacing=0><tr><td><font size=2><b>Access restricted</b></font></td></tr></table>~;
	exit;
}
}
if (!$ENV{HTTP_USER_AGENT} && $logagentfault)
{
	open(F,">>$basepath/$user/ca.log");
	flock(F,$LOCK_EX);
	$acdate=scalar gmtime(time+$gmtzone*3600);
	print F "$acdate\tCant resolve user agent\t$ENV{REMOTE_ADDR}\n";
	flock(F,$LOCK_UN);
	close(F);
}
open (F,">$basepath/$user/lastact");
flock(F,$LOCK_EX);
print F $lastact;
flock(F,$LOCK_UN);
close (F);
open (FICR,"<$basepath/credits.spx");
flock(FICR,$LOCK_EX);
@credits=<FICR>;
flock(FICR,$LOCK_UN);
close (FICR);
foreach(@credits)
{
	chop;
	($tusr,$tval)=split("\t",$_);
	$credit{$tusr}=$tval;
}
open (F, "<$basepath/adcenter.db");
flock(F,$LOCK_EX);
while($line=<F>)
{
	chop($line);
	($username,$url,$usrgroup,$country,$ratio,$referuser,$weight)=split("\t",$line);
	if ($username eq $user)
	{
		$userratio=$ratio;
		$refus=$referuser;
		$usersurl=$url;
		next;
	}
	$weight=1 if (!$weight || $weight==0);
	if (($credit{$username}>1 || -e "$basepath/$username/nonexpired") && !(-e "$basepath/$username/dflag") && $cook{smartshow_spx}!=~/,$username,/)
	{
	$j=0;
	while ($j<$weight)
	{
		push(@data,$username);
		$j++;
	}
	}
}
flock(F,$LOCK_UN);
close (F);
$i=0;
srand;
$item=int(rand (@data));
$username=$data[$item];
$username=$yourname unless (@data);
if (-e "$basepath/$username/affiliate.spx")
{
open (F,"+<$basepath/$username/affiliate.spx");
flock(F,$LOCK_EX);
@lines=<F>;
foreach (@lines)
{
	($arg1,$arg2,$arg3,$arg4)=split("\t",$_);
	if ($arg1 eq $user)
	{
		$arg3++;
		$_="$arg1\t$arg2\t$arg3\t$arg4";
		$foundflag=1;
		last;
	}
}
push (@lines,"$user\t$usersurl\t1\t0\n") if (!$foundflag);
truncate(F,0);
seek(F,0,0);
print F @lines;
flock(F,$LOCK_UN);
close (F);
}
else
{
open (F,">$basepath/$username/affiliate.spx");
flock(F,$LOCK_EX);
print F "$user\t$usersurl\t1\t0\n";
flock(F,$LOCK_UN);
close (F);
}

open (F,"<$adcpath/template/spx.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "Refresh: $spdelay;url=$cgi/adcrdspx.pl?$username&$user\n";
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
